# Table of Contents

* [Telepresence](INDEX.md)

----

## Getting started

* [Introduction to Telepresence](discussion/overview.md)
* [Why Telepresence?](discussion/why-telepresence.md)
* [Installing Telepresence](reference/install.md)
* [Fast dev workflow with Docker/K8S](tutorials/docker.md)

## Tutorials

* [Debug a Kubernetes service locally](tutorials/kubernetes.md)
* [Connect to a remote Kubernetes cluster](tutorials/kubernetes-client.md)
* [Rapid development with Kubernetes](tutorials/kubernetes-rapid.md)
* [Get started with OpenShift](tutorials/openshift.md)
* [Minikube VPN access](tutorials/minikube-vpn.md)
* [Using a Kubernetes Client Library](tutorials/kubernetes-client-libs.md)
* [Using Telepresence with Golang](howto/golang.md)
* [Local Java development](tutorials/java.md)
* [Using Telepresence with IntelliJ](tutorials/intellij.md)
* [Using Telepresence with PHP](tutorials/php.md)

## Reference

* [Connecting to the cluster](reference/connecting.md)
* [Proxying methods](reference/methods.md)
  * [What gets proxied](reference/proxying.md)
  * [Volume access](howto/volumes.md)
* [Running local processes](reference/running.md)
* [Generic limitations & workarounds](reference/limitations.md)
* [Windows support](reference/windows.md)
* [Usage Reporting](reference/usage_reporting.md)
* [How it works](discussion/how-it-works.md)
* [Upgrading Telepresence](reference/upgrade.md)

## Community

* [Development Guide](reference/developing.md)
* [Community](reference/community.md)
* [Related Projects](reference/related-projects.md)
* [Case Studies](https://www.telepresence.io/case-studies)
* [Changelog](reference/changelog.md)

## Need Help?

* [Ask on Slack](https://d6e.co/slack)
* [File a GitHub Issue](https://github.com/datawire/telepresence/issues/new)
* [Visit Datawire.io](https://www.datawire.io)
