# Community

### Ensuring Telepresence works well for everyone

We're always looking to collect more feedback and learn more about your use case for Telepresence. If you have questions, ask them in our [Slack chatroom](https://d6e.co/slack) or [file an issue on GitHub](https://github.com/datawire/telepresence/issues/new).

### What other people are saying about Telepresence

##### [Telepresence for Local Development](https://blog.openshift.com/telepresence-local-development/) - Michael Hausenblas
OpenShift makes it easy to deploy your containers, but it can also impact your development cycle. This post covers how you can use Telepresence with OpenShift for faster local development.

##### [Run a local process in Kubernetes with Telepresence](https://blog.codersociety.com/run-a-local-process-in-kubernetes-with-telepresence-dc16bd593b52) - Kentaro Wakayama
This post walks through how the engineers at Coder Society use Telepresence in their Kubernetes development stack to gain access to running Kubernetes services without having to expose them publicly.

##### [Smarter local development of Kubernetes microservices with Telepresence](http://blog.stacktical.com/cloud-computing/2017/09/27/telepresence-kubernes-development.html) - [Stacktical](https://stacktical.com)
Installing projects locally as a developer has always been tedious, and microservices make that even more complicated. In this post, Stacktical talks about how Telepresence makes it super fast and easy for them to work amongst existing Kubernetes microservices.

##### [5 open source tools for microservices developers on Kubernetes](https://hackernoon.com/5-open-source-tools-for-microservices-developers-on-kubernetes-4fac73c2c6ee) - Richard Li
Kubernetes has powerful features for container scheduling, service discovery, and load balancing, but what tools exist for developers who are developing software on Kubernetes? This post covers 5 popular open source tools, including Telepresence!

##### [Using Telepresence for Kubernetes Development](https://youtu.be/G8fA_JssUG8) - Michael Hausenblas & Abhay Saxena
In this video interview, Michael Hausenblas of Red Hat interviews Abhay Saxena, the lead engineer on Telepresence.

##### [10 open-source Kubernetes tools for highly effective SRE and Ops Teams](https://abhishek-tiwari.com/10-open-source-tools-for-highly-effective-kubernetes-sre-and-ops-teams/) - Abhishek Tiwari
Abhishek Tiwari, head of engineering at Isentia, reviews 10 open source Kubernetes tools, including Telepresence.

##### [Productive Dev Environments for Kubernetes](https://youtu.be/4cct9JgItYQ) - Philip Lombardi
This talk from the NYC Kubernetes meetup covers strategies and trade-offs for setting up productive and realistic development environments for microservices and includes a demo of Telepresence.

##### [Running Spark Drivers with Telepresence](https://www.datawire.io/running-spark-drivers-with-telepresence/) - Nate Buesgens
The team at [vizual.ai](https://www.vizual.ai) uses Spark for analyzing and modeling clickstream data, Kubernetes for orchestrating their Spark cluster, and Telepresence to make the Spark application development workflow more efficient.

##### [Writing golang applications designed to run in Kubernetes](https://github.com/number101010/go-kubernetes-vscode-dev) - number101010
This repo is a template to get started writing golang applications designed to run in Kubernetes and uses Telepresence to mimic the in-cluster environment.

##### [Towards a better service development story](https://blog.ironcladapp.com/towards-a-better-service-development-story-bae19a9b3c5a) - Dylan Scott
The team at Ironclad is using Telepresnece to develop individual Kubernetes services and improve their development workflow on Kubernetes. 

###### If you're interested in sharing your use case for Telepresence, we'd love to hear it! You can reach out to us in the [Slack chatroom](https://d6e.co/slack) or [submit a pull request](https://github.com/datawire/telepresence/pulls).
